Loading...
Searching...
No Matches
bliss Namespace Reference

## Classes

class | TreeNode
class | AbstractGraph
| An abstract base class for different types of graphs. More...
class | BigNum
| A simple wrapper class for non-negative big integers (or approximation of them). More...
class | Digraph
| The class for directed, vertex colored graphs. More...
class | Graph
| The class for undirected, vertex colored graphs. More...
class | Heap
| A min-heap of unsigned integers. More...
class | KQueue
| A simple implementation of queues with fixed maximum capacity. More...
class | Orbit
| A class for representing orbit information. More...
class | Partition
| A class for refinable, backtrackable ordered partitions. More...
class | Stats
| Statistics returned by the bliss search algorithm. More...
class | Timer
| A simple helper class for measuring elapsed time. More...
class | UintSeqHash
| A updatable hash for sequences of unsigned ints. More...

## Functions

size_t | print_permutation (FILE *const fp, const unsigned int N, const unsigned int *perm, const unsigned int offset)
size_t | print_permutation (FILE *const fp, const std::vector< unsigned int > &perm, const unsigned int offset)
bool | is_permutation (const unsigned int N, const unsigned int *perm)
bool | is_permutation (const std::vector< unsigned int > &perm)

## Variables

static const char *const | version = "0.77"
| The version number of bliss.

## Detailed Description

The namespace bliss contains all the classes and functions of the bliss tool except for the C programming language API.

## Function Documentation

## is_permutation() [1/2]

bool bliss::is_permutation | ( | const std::vector< unsigned int > & | perm | ) |

Check whether perm is a valid permutation on {0,...,N-1}. Slow, mainly for debugging and validation purposes.

## is_permutation() [2/2]

bool bliss::is_permutation | ( | const unsigned int | N,
|  | const unsigned int * | perm )

Check whether perm is a valid permutation on {0,...,N-1}. Slow, mainly for debugging and validation purposes.

## print_permutation() [1/2]

size_t bliss::print_permutation | ( | FILE * | fp,
|  | const std::vector< unsigned int > & | perm,
|  | const unsigned int | offset = 0 )

Print the permutation perm of {0,...,N-1} in the cycle format in the file stream fp. The amount offset is added to each element before printing, e.g. the permutation (2 4) is printed as (3 5) when offset is 1.

## print_permutation() [2/2]

size_t bliss::print_permutation | ( | FILE * | fp,
|  | const unsigned int | N,
|  | const unsigned int * | perm,
|  | const unsigned int | offset = 0 )

Print the permutation perm of {0,...,N-1} in the cycle format in the file stream fp. The amount offset is added to each element before printing, e.g. the permutation (2 4) is printed as (3 5) when offset is 1.